#include "systemc.h"
#ifndef IDCT_UTIL_H
#include "IDCT_util.h"
#endif
#include "Idct_fix.h"
#include "stimuli.h"
#include "CheckRes.h"


FILE *fip;  
FILE *fileResult;  

int main(int argc, char * argv[])
{
	int CptSimul=0;
  	int tmp;
	
	sc_signal<bool>		start;
	sc_signal<bool>		NewMB;
	sc_signal<bool>		DATA_SENT;
	sc_signal<bool>		DCT_OK;
	sc_signal<short>		MB_lu;
	sc_signal<short>		MB_ecr;
	
   sc_clock clock("clock",10); 
	
	IDCT IDCT1("calcul");
	IDCT1 << clock << start << NewMB << MB_lu << DATA_SENT << MB_ecr;

	STIM STIMULI1("Stimul");
	STIMULI1 << clock << DATA_SENT << NewMB << MB_lu;

   CheckRes Check("Validation");
	Check << clock << MB_ecr << DATA_SENT << DCT_OK;
		
   sc_trace_file *DCT_trace;
   DCT_trace= sc_create_wif_trace_file("./IDCT");  
   
   sc_trace(DCT_trace,clock,"clock");
   sc_trace(DCT_trace,start,"start");
   sc_trace(DCT_trace,NewMB,"NewMB");
   sc_trace(DCT_trace,DCT_OK,"DCT_OK");
   sc_trace(DCT_trace,DATA_SENT,"DATA_SENT");
   sc_trace(DCT_trace,MB_lu,"MB_lu");
   sc_trace(DCT_trace,MB_ecr,"MB_ecr");



	fip=fopen("./Block_Entree.txt","r");
   fileResult=fopen("./Block_Sortie.txt","r");
	if (fip==NULL)
		cout<<"fichier./Block_Entree.txt inexistant"<<endl<<endl;
	if (fileResult==NULL)
		cout<<"fichier./Block_Sortie.txt inexistant"<<endl<<endl;
	
	start=true;
	
	while(CptSimul<100){
		sc_start(20);
		if(DCT_OK.delayed()==true){
			cout<<"temps de simulation : "<<sc_time_stamp()<<endl;
			cout<<"nouveau run de simulation [0/1] ? : ";
			cin>>tmp;
			cout<<endl;
			CptSimul++;
			if(tmp==0){
    			 fclose(fip); 
   			 fclose(fileResult);
 				 sc_close_wif_trace_file(DCT_trace);
				return(0);
			}
		}
	}

	return(0);
	
}
	
	
